---
title: PaymentResponse.shippingAddress
slug: Web/API/PaymentResponse/shippingAddress
tags:
  - API
  - Experimental
  - Payment Request
  - Payment Request API
  - PaymentResponse
  - Property
  - Reference
  - Secure context
  - shippingAddress
---
<p>{{securecontext_header}}{{SeeCompatTable}}{{APIRef("Payment Request API")}}</p>

<p>The <strong><code>shippingAddress</code></strong> read-only property of the <code>PaymentRequest</code> interface returns a {{domxref('PaymentAddress')}} object containing the shipping address provided by the user.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>shippingAddress</em> = <em>PaymentRequest</em>.shippingAddress;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("PaymentAddress")}} object providing details comprising the shipping address provided by the user.</p>

<h2 id="Example">Example</h2>

<p>Generally, the user agent will fill the <code>shippingAddress</code> property for you. You can trigger this by setting <code>PaymentOptions.requestShipping</code> to <code>true</code> when calling the {{domxref('PaymentRequest.paymentRequest','PaymentRequest')}} constructor.</p>

<p>In the example below, the cost of shipping varies by geography. When the {{domxref('PaymentRequest.onshippingaddresschange')}} is called, <code>updateDetails()</code> is called to update the details of the <code>PaymentRequest</code>, using <code>shippingAddress</code> to set the correct shipping cost.</p>

<pre class="brush: js">// Initialization of PaymentRequest arguments are excerpted for brevity.

var payment = new PaymentRequest(supportedInstruments, details, options);

request.addEventListener('shippingaddresschange', function(evt) {
  evt.updateWith(new Promise(function(resolve) {
    updateDetails(details, request.shippingAddress, resolve);
  }));
});

payment.show().then(function(paymentResponse) {
  // Processing of paymentResponse exerpted for the same of brevity.
}).catch(function(err) {
  console.error("Uh oh, something bad happened", err.message);
});

function updateDetails(details, shippingAddress, resolve) {
  if (shippingAddress.country === 'US') {
    var shippingOption = {
      id: '',
      label: '',
      amount: {currency: 'USD', value: '0.00'},
      selected: true
    };
    if (shippingAddress.region === 'MO') {
      shippingOption.id = 'mo';
      shippingOption.label = 'Free shipping in Missouri';
      details.total.amount.value = '55.00';
    } else {
      shippingOption.id = 'us';
      shippingOption.label = 'Standard shipping in US';
      shippingOption.amount.value = '5.00';
      details.total.amount.value = '60.00';
    }
    details.displayItems.splice(2, 1, shippingOption);
    details.shippingOptions = [shippingOption];
  } else {
    delete details.shippingOptions;
  }
  resolve(details);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<p>{{Compat("api.PaymentResponse.shippingAddress")}}</p>
